

#include <time.h>

#include "Application.h"


Application::Application()
{
}



Application::~Application()
{
}



void Application::init()
{
	// Inputs initialization
}



void Application::exit()
{
}


void Application::draw()
{
	// [!] Drawing code ONLY. Logic forbidden [!]
	
	// Clear depth buffer

	// Draw	
}



void Application::contextInit()
{
	// Initialization of data bound to GL-context

	
	// TODO: uncomment and update functions once you want to make use of display lists and textures
	
	//GenerateCubeDList();
	//GenerateCheckeredTexture();
}


void Application::bufferPreDraw()
{
	// Clear color buffer
}


void Application::contextPreDraw()
{
}


void Application::preFrame()
{
}


void Application::latePreFrame()
{
	// Query peripherals for their up-to-date data
	// Update scene

	// [!] Application logic is meant to be processed here only [!]
}


float Application::getDrawScaleFactor()
{
	// Defines draw scale

	return 0;		// Replace by appropriate value
}



void Application::DrawCross(float size)
{
	// Draw a frame located at origin
	// frame size is give by parameter
	// Use thick lines
	// Don't use pure red/green/blue colors for axis to make some difference w/ vrj own frame
}


void Application::DrawGrid(float size, unsigned int halfSteps)
{
	// Draw a grid - (xOz) plane
	
	// grid centered at origin
	// grid goes from from -size to +size in the x and z directions
	// grid made out of (2 * halfsteps + 1) lines along each direction 

}


void Application::DrawRay(float length)
{
	// Draw a ray from the wand, along its orientation
	
	// length: length of ray
}


void Application::DrawUnitCube()
{
	// TODO: change to use display list

	UnitCubeGeometry();
}



void Application::GenerateCubeDList()
{
	GLuint listId = glGenLists(1);

	glNewList(listId, GL_COMPILE);
	UnitCubeGeometry();
	glEndList();
	
	

	// TODO if display list is to be used
	// Properly store list id	
}


void Application::UnitCubeGeometry()
{
	glBegin(GL_QUADS);

	glNormal3f(0.0f, 0.0f, 1.0f);
	glColor3ub(0, 0, 0xC0);

	glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, 0.5f); 
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.5f, -0.5f, 0.5f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.5f,  0.5f, 0.5f);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f,  0.5f, 0.5f);



	glNormal3f(0.0f, 0.0f, -1.0f);
	glColor3ub(0, 0, 0x30);

	glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, -0.5f);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f,  0.5f, -0.5f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.5f,  0.5f, -0.5f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.5f, -0.5f, -0.5f);



	glNormal3f(1.0f, 0.0f, 0.0f);
	glColor3ub(0xC0, 0, 0);

	glTexCoord2f(0.0f, 0.0f); glVertex3f(0.5f, -0.5f,  0.5f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(0.5f, -0.5f, -0.5f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(0.5f,  0.5f, -0.5f);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(0.5f,  0.5f,  0.5f);



	glNormal3f(-1.0f, 0.0f, 0.0f);
	glColor3ub(0x30, 0, 0);

	glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, -0.5f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.5f, -0.5f,  0.5f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.5f,  0.5f,  0.5f);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f,  0.5f, -0.5f);



	glNormal3f(0.0f, 1.0f, 0.0f);
	glColor3ub(0, 0xC0, 0);

	glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, 0.5f,  0.5f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.5f, 0.5f,  0.5f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.5f, 0.5f, -0.5f);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, 0.5f, -0.5f);



	glNormal3f(0.0f, -1.0f, 0.0f);
	glColor3ub(0, 0x30, 0);

	glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.5f, -0.5f, -0.5f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.5f, -0.5f, -0.5f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.5f, -0.5f,  0.5f);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.5f, -0.5f,  0.5f);

	glEnd();
}


void Application::GenerateCheckeredTexture()
{
	GLuint tmpTexId;
	glGenTextures(1, &tmpTexId);

	glBindTexture(GL_TEXTURE_2D, tmpTexId);


	unsigned char* data = new unsigned char[256 * 256 * 3];
	unsigned char* p = data;

	for(unsigned int j = 0 ; j < 256 ; j++)
		for(unsigned int i = 0 ; i < 256 ; i++)
		{
			unsigned char value = (((i ^ j) >> 4) & 1) ? 0x80 : 0xA0;

			*p++ = value;
			*p++ = value;
			*p++ = value;
		}


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, data);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);


	delete[] data;
	

	// TODO if texture is to be used
	// Properly store texture id		
}
